VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form fDIRECTEMP_VB6_Example 
   Caption         =   "DIRECTEMP VB6 Example"
   ClientHeight    =   7800
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6870
   LinkTopic       =   "Form1"
   ScaleHeight     =   7800
   ScaleWidth      =   6870
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Single Temperature Point"
      Height          =   375
      Left            =   720
      TabIndex        =   10
      Top             =   3960
      Width           =   2655
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   5280
      Top             =   1440
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      CommPort        =   5
      DTREnable       =   0   'False
      InBufferSize    =   512
      InputLen        =   1
      RThreshold      =   1
      BaudRate        =   115200
      SThreshold      =   1
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   600
      Top             =   1440
   End
   Begin VB.TextBox tbInput 
      Height          =   2535
      Left            =   480
      MultiLine       =   -1  'True
      TabIndex        =   7
      Top             =   4800
      Width           =   5775
   End
   Begin VB.Frame Frame1 
      Height          =   2295
      Left            =   480
      TabIndex        =   3
      Top             =   2280
      Width           =   5775
      Begin VB.OptionButton rbdF 
         Caption         =   "F"
         Height          =   255
         Left            =   1680
         TabIndex        =   12
         Top             =   840
         Width           =   495
      End
      Begin VB.OptionButton rbdC 
         Caption         =   "C"
         Height          =   255
         Left            =   960
         TabIndex        =   11
         Top             =   840
         Value           =   -1  'True
         Width           =   495
      End
      Begin VB.TextBox TimeInterval 
         Height          =   285
         Left            =   3720
         TabIndex        =   6
         Text            =   "1"
         Top             =   1320
         Width           =   615
      End
      Begin VB.CheckBox cbTimed 
         Caption         =   "Timed Temperature"
         Height          =   375
         Left            =   720
         TabIndex        =   4
         Top             =   360
         Width           =   2295
      End
      Begin VB.Label Label2 
         Caption         =   "Measurement Interval (seconds)"
         Height          =   255
         Left            =   840
         TabIndex        =   5
         Top             =   1320
         Width           =   2295
      End
   End
   Begin VB.ComboBox cbSerialPorts 
      Height          =   315
      Left            =   2640
      TabIndex        =   0
      Text            =   "-"
      Top             =   480
      Width           =   2655
   End
   Begin VB.Label lcomport 
      BackColor       =   &H000000FF&
      Height          =   495
      Left            =   5520
      TabIndex        =   9
      Top             =   360
      Width           =   375
   End
   Begin VB.Label Label3 
      Caption         =   "Input"
      Height          =   375
      Left            =   480
      TabIndex        =   8
      Top             =   4560
      Width           =   1215
   End
   Begin VB.Label tbTemp 
      Alignment       =   2  'Center
      BackColor       =   &H8000000D&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "--"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   1680
      TabIndex        =   2
      Top             =   1320
      Width           =   2895
   End
   Begin VB.Label lSerialPort 
      Caption         =   "Serial Port"
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   480
      Width           =   1215
   End
End
Attribute VB_Name = "fDIRECTEMP_VB6_Example"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' This Visual Basic 6 example is provide by QTI to help the end user use the DIRECTEMP USB temperature sensor with their PC
' This code is provided as-is and there is no warranty expressed or implied.
' by using this code you agree to hold Quality Thermistor, Inc. blameless for any damage direct or incidental as a result of using this code
'
' USB serial DIRECTEMP devices will deliver an ASCII character temperature in C when the user requests a data point.
' By sending the number 2 to the device, it will respond with the temperature in celcius.
' Conversion from celcius to Fahrenheit (F) = C * 9/5 + 32
' The device will report its serial number and firmware version with the number 3
' The device will non-stop stream temperature data with the number 1
' The device will stop streaming data with the letter x
'
' VB6 uses the mscomm control to communicate with the com ports in windows 2k and XP.
' The program performs the following steps
' 1 Set the com port number and open the port.
' 2 Output the command character
' 3 Read the port input in the oncomm event and concatentate the input results and display it.
'
Dim logfile As Boolean
Dim mode As Integer
Dim fileNa As String
Dim Data As String
Dim ManBuffer As String
Dim SerialOpened As Boolean
Dim newdata As String
Dim counter As Integer
Dim proceed As Boolean

Option Explicit
    
Public Function SerialOpen(Optional ByVal statusOnly As Boolean = False) As Boolean
        
    Dim inbuff As String

    If statusOnly = True Then
        MSComm1.PortOpen = True
        inbuff = MSComm1.Input           ''Flush the port's input buffer whenever it is opened
        SerialOpened = True
        SerialOpen = True
        Exit Function
    Else
        MSComm1.PortOpen = False
        inbuff = MSComm1.Input           ''Flush the port's input buffer whenever it is opened
        SerialOpened = False
        SerialOpen = False
        Exit Function
    End If
localhandler:
        'Catch ex As Exception
    SerialOpened = False
    SerialOpen = False
    MsgBox ("Unable to open Serial Port")
    Exit Function
            'End Try
End Function

Public Sub CommSend(ByVal Output As String)
    Dim serstring As Integer
    Dim test1 As Integer
    Dim test2 As Integer
    
    serstring = CInt(cbSerialPorts.text)
    test2 = InStr(serstring, "-") <> 0
    
    If cbSerialPorts.text <> "-" Then
        If Not SerialOpened Then
            MSComm1.CommPort = serstring
            SerialOpened = SerialOpen(True)
        End If
        If SerialOpened Then
            tbInput.text = ""
            ManBuffer = ""
            MSComm1.Output = Output
        Else
            tbInput.text = "send error"
        End If
        If Not InStr(Output, Chr(13), vbTextCompare) Then
            'tbSent.Text = Output
        End If
    End If
End Sub


Private Sub cbSerialPorts_Change()
    Dim text As String
    If cbTimed.Value = True Then
        cbTimed.Value = False
        Timer1.Enabled = False
        mode = 0
    End If
    Dim p1 As Integer
    If cbSerialPorts.text = "-" Then
        If MSComm1.PortOpen = True Then
            MSComm1.PortOpen = False
        End If
        SerialOpened = False
        cbSerialPorts.Clear
        cbSerialPorts.AddItem ("-")
        Dim i As Integer
        For i = 1 To 150
            COMCheck (i)
        Next
    Else
        p1 = CInt(cbSerialPorts.SelText)
        If MSComm1.PortOpen = True Then
            MSComm1.PortOpen = False
            SerialOpened = False
        End If
        MSComm1.CommPort = p1
        If SerialOpen(True) Then
            'lCommPort.text = CStr(p1)
            'lCommPort.BackColor = &H8000
            cbSerialPorts.text = MSComm1.CommPort
        Else
            'lCommPort.text = "?"
            'lCommPort.BackColor = &H21
        End If
    End If
    On Error GoTo localhandler
    Exit Sub
localhandler:
    MsgBox ("Unexpected port error")
    Exit Sub
End Sub

Private Sub cbTimed_Click()
    If cbTimed.Value = 1 Then
        mode = 1
        CommSend ("2")
        TimeInterval.Enabled = False
        Timer1.Interval = CInt(TimeInterval.text) * 1000
        Timer1.Enabled = True
    Else
        TimeInterval.Enabled = True
        Timer1.Enabled = False
    End If
End Sub

Private Function COMCheck(ByVal Port As Integer) As Boolean
    On Error GoTo localhandler
    'Returns false if port cannot be opened or does not exist
    'Returns true if port is available and can be opened
    If MSComm1.PortOpen = True Then
        COMCheck = False: Exit Function
    Else
        'Test the port by opening and closing it
        MSComm1.CommPort = Port
        MSComm1.PortOpen = True
        If MSComm1.PortOpen = True Then  ' if open, then wait and then close
            cbSerialPorts.AddItem (CStr(Port))
            Dim i As Integer
            Dim n As Double
            For i = 1 To 90000
                n = 281742390587.657 * (45634340589.5679 + i)
            Next
            COMCheck = True
            MSComm1.PortOpen = False
        Else
            COMCheck = False
        End If
        Exit Function
    End If
localhandler:
    Debug.Print ("Error port" & CStr(Port))
    COMCheck = False
    Resume Next
End Function
    
Private Sub Command1_Click()
    mode = 1
    Data = ""
    CommSend ("2")
End Sub

Private Sub Form_Load()
    Dim i As Integer
    cbSerialPorts.AddItem "-"
    For i = 1 To 150
        COMCheck (i)
    Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo localhandler
    Timer1.Enabled = False
    If MSComm1.PortOpen = True Then
            MSComm1.PortOpen = False
    End If
    Exit Sub
localhandler:
        MsgBox ("Unexpected rejection on comm port")
    Exit Sub
End Sub


Private Sub MSComm1_OnComm()
    Select Case MSComm1.CommEvent
        Case comEvReceive

            newdata = CStr(MSComm1.Input)
            Debug.Print ("data received: " & newdata)
            For counter = 1 To Len(newdata)
                If Mid(newdata, counter, 1) = Chr(13) Then     ' check buffer length is greater than nothing
                    proceed = True
                    Data = Data & Mid(newdata, 1, counter - 1)
                Else
                    proceed = False
                End If
            Next
            If proceed Then                                 ' an end of line character (carriage return chr (13) detected proceed
                Select Case mode
                    Case 1 ' run temperature
                        ManBuffer = Data                    ' set the incomming buffer
                        tbInput.text = Data                 ' set the display text box to show the incoming data
                        Data = ""
                        If rbdC.Value = True Then           ' check the temperature unit setting
                            tbTemp.Caption = ManBuffer      ' record the temperature and show it on screen
                        Else
                            ManBuffer = CStr(CDbl(ManBuffer) * 9 / 5 + 32)
                            tbTemp.Caption = ManBuffer
                        End If
                    Case 0 ' if not gathering temperature, process other data
                        If newdata = Chr(13) Then
                            ManBuffer = Data
                            Data = ""
                        Else
                            Data = Data + newdata
                        End If
                End Select
            Else
                If Asc(newdata) < 58 And Asc(newdata) >= 45 And Asc(newdata) <> 47 Then
                    Data = Data + newdata
                End If
            End If
    End Select

    On Error GoTo localhandler
    Exit Sub
localhandler:
    MsgBox ("Unexpected communication type")
    Resume Next
End Sub

Private Sub rbdC_Click()
    If rbdC.Value = True Then
        rbdF.Value = False
    End If
End Sub

Private Sub rbdF_Click()
    If rbdF.Value = True Then
        rbdC.Value = False
    End If
End Sub


Private Sub Timer1_Timer()
    mode = 1
    CommSend ("2")
End Sub
